<?php

require_once(dirname(__FILE__) . '/../lib/lib_dolimapmail.php');

class ActionsDolimapmail {

    /** Overloading the doActions function : replacing the parent's function with the one below 
     *  @param      parameters  meta datas of the hook (context, etc...) 
     *  @param      object             the object you want to process (an invoice if you are in invoice module, a propale in propale's module, etc...) 
     *  @param      action             current action (if set). Generally create or edit or null 
     *  @return       void 
     */
    function doActions($parameters, &$object, &$action, $hookmanager) {
        global $langs, $user, $db, $conf;

        if ($action === "send" && $conf->global->DOLIMAPMAIL_COPY_SENT_MAIL) {
            switch ($parameters['context']) {
                case 'propalcard':
                    if (!GETPOST('addfile') && !GETPOST('removedfile') && !GETPOST('cancel')) {
                        $langs->load('mails');

                        $result = $object->fetch(GETPOST("id"));
                        $result = $object->fetch_thirdparty();

                        if ($result > 0) {
                            if (GETPOST('sendto')) {
                                // Le destinataire a ete fourni via le champ libre
                                $sendto = GETPOST('sendto');
                                $sendtoid = 0;
                            }
                            elseif (GETPOST('receiver') != '-1') {
                                // Recipient was provided from combo list
                                if (GETPOST('receiver') === 'thirdparty') { // Id of third party
                                    $sendto = $object->client->email;
                                    $sendtoid = 0;
                                }
                                else { // Id du contact
                                    $sendto = $object->client->contact_get_property(GETPOST('receiver'),
                                            'email');
                                    $sendtoid = GETPOST('receiver');
                                }
                            }

                            if (dol_strlen($sendto)) {
                                $langs->load("commercial");

                                $from = GETPOST('fromname') . ' <' . GETPOST('frommail') . '>';
                                $replyto = GETPOST('replytoname') . ' <' . GETPOST('replytomail') . '>';
                                $message = GETPOST('message');
                                $sendtocc = GETPOST('sendtocc');
                                $deliveryreceipt = GETPOST('deliveryreceipt');

                                if (GETPOST('action') === 'send') {
                                    if (dol_strlen(GETPOST('subject')))
                                        $subject = GETPOST('subject');
                                    else
                                        $subject = $langs->transnoentities('Propal') . ' ' . $object->ref;
                                    $actiontypecode = 'AC_PROP';
                                    $actionmsg = $langs->transnoentities('MailSentBy') . ' ' . $from . ' ' . $langs->transnoentities('To') . ' ' . $sendto . ".\n";
                                    if ($message) {
                                        $actionmsg.=$langs->transnoentities('MailTopic') . ": " . $subject . "\n";
                                        $actionmsg.=$langs->transnoentities('TextUsedInTheMessageBody') . ":\n";
                                        $actionmsg.=$message;
                                    }
                                    $actionmsg2 = $langs->transnoentities('Action' . $actiontypecode);
                                }

                                // Create form object
                                include_once(DOL_DOCUMENT_ROOT . '/core/class/html.formmail.class.php');
                                $formmail = new FormMail($db);

                                $attachedfiles = $formmail->get_attached_files();
                                $filepath = $attachedfiles['paths'];
                                $filename = $attachedfiles['names'];
                                $mimetype = $attachedfiles['mimes'];

                                // Envoi de la propal
                                require_once(DOL_DOCUMENT_ROOT . '/core/class/CMailFile.class.php');
                                $mailfile = new CMailFile($subject, $sendto,
                                        $from, $message, $filepath, $mimetype,
                                        $filename, $sendtocc, '',
                                        $deliveryreceipt);

                                if (!$mailfile->error) {
                                    $mailfile->message = stripslashes($mailfile->message);

                                    $msg_prepared = $mailfile->headers . $mailfile->eol;
                                    if (strpos($mailfile->headers, "To: ") === FALSE)
                                        $msg_prepared .= "To: " . $mailfile->getValidAddress($sendto,
                                                        0, 1) . $mailfile->eol2;
                                    $msg_prepared .= $mailfile->subject . $mailfile->eol;
                                    $msg_prepared .= $mailfile->message . $mailfile->eol;

                                    $object->msg_imap_result = store_email_into_folder($msg_prepared,
                                            $conf->global->DOLIMAPMAIL_FOLDER_COPY_SENT_MAIL);
                                }
                            }
                        }
                    }
                    break;
                case 'ordercard':
                    if (!GETPOST('addfile') && !GETPOST('removedfile') && !GETPOST('cancel')) {
                        $langs->load('mails');

                        $result = $object->fetch(GETPOST("id"));
                        $result = $object->fetch_thirdparty();

                        if ($result > 0) {
                            if (GETPOST('sendto')) {
                                // Le destinataire a ete fourni via le champ libre
                                $sendto = GETPOST('sendto');
                                $sendtoid = 0;
                            }
                            elseif (GETPOST('receiver') != '-1') {
                                // Recipient was provided from combo list
                                if (GETPOST('receiver') === 'thirdparty') { // Id of third party
                                    $sendto = $object->client->email;
                                    $sendtoid = 0;
                                }
                                else { // Id du contact
                                    $sendto = $object->client->contact_get_property(GETPOST('receiver'),
                                            'email');
                                    $sendtoid = GETPOST('receiver');
                                }
                            }

                            if (dol_strlen($sendto)) {
                                $langs->load("commercial");

                                $from = GETPOST('fromname') . ' <' . GETPOST('frommail') . '>';
                                $replyto = GETPOST('replytoname') . ' <' . GETPOST('replytomail') . '>';
                                $message = GETPOST('message');
                                $sendtocc = GETPOST('sendtocc');
                                $deliveryreceipt = GETPOST('deliveryreceipt');

                                if (GETPOST('action') === 'send') {
                                    if (dol_strlen(GETPOST('subject')))
                                        $subject = GETPOST('subject');
                                    else
                                        $subject = $langs->transnoentities('Propal') . ' ' . $object->ref;
                                    $actiontypecode = 'AC_PROP';
                                    $actionmsg = $langs->transnoentities('MailSentBy') . ' ' . $from . ' ' . $langs->transnoentities('To') . ' ' . $sendto . ".\n";
                                    if ($message) {
                                        $actionmsg.=$langs->transnoentities('MailTopic') . ": " . $subject . "\n";
                                        $actionmsg.=$langs->transnoentities('TextUsedInTheMessageBody') . ":\n";
                                        $actionmsg.=$message;
                                    }
                                    $actionmsg2 = $langs->transnoentities('Action' . $actiontypecode);
                                }

                                // Create form object
                                include_once(DOL_DOCUMENT_ROOT . '/core/class/html.formmail.class.php');
                                $formmail = new FormMail($db);

                                $attachedfiles = $formmail->get_attached_files();
                                $filepath = $attachedfiles['paths'];
                                $filename = $attachedfiles['names'];
                                $mimetype = $attachedfiles['mimes'];

                                // Envoi de la propal
                                require_once(DOL_DOCUMENT_ROOT . '/core/class/CMailFile.class.php');
                                $mailfile = new CMailFile($subject, $sendto,
                                        $from, $message, $filepath, $mimetype,
                                        $filename, $sendtocc, '',
                                        $deliveryreceipt);

                                if (!$mailfile->error) {
                                    $mailfile->message = stripslashes($mailfile->message);

                                    $msg_prepared = $mailfile->headers . $mailfile->eol;
                                    if (strpos($mailfile->headers, "To: ") === FALSE)
                                        $msg_prepared .= "To: " . $mailfile->getValidAddress($sendto,
                                                        0, 1) . $mailfile->eol2;
                                    $msg_prepared .= $mailfile->subject . $mailfile->eol;
                                    $msg_prepared .= $mailfile->message . $mailfile->eol;

                                    $object->msg_imap_result = store_email_into_folder($msg_prepared,
                                            $conf->global->DOLIMAPMAIL_FOLDER_COPY_SENT_MAIL);
                                }
                            }
                        }
                    }
                    break;
                case 'invoicecard':
                    if (!GETPOST('addfile') && !GETPOST('removedfile') && !GETPOST('cancel')) {
                        $langs->load('mails');

                        $result = $object->fetch(GETPOST("id"));
                        $result = $object->fetch_thirdparty();

                        if ($result > 0) {
                            if (GETPOST('sendto')) {
                                // Le destinataire a ete fourni via le champ libre
                                $sendto = GETPOST('sendto');
                                $sendtoid = 0;
                            }
                            elseif (GETPOST('receiver') != '-1') {
                                // Recipient was provided from combo list
                                if (GETPOST('receiver') === 'thirdparty') { // Id of third party
                                    $sendto = $object->client->email;
                                    $sendtoid = 0;
                                }
                                else { // Id du contact
                                    $sendto = $object->client->contact_get_property(GETPOST('receiver'),
                                            'email');
                                    $sendtoid = GETPOST('receiver');
                                }
                            }

                            if (dol_strlen($sendto)) {
                                $langs->load("commercial");

                                $from = GETPOST('fromname') . ' <' . GETPOST('frommail') . '>';
                                $replyto = GETPOST('replytoname') . ' <' . GETPOST('replytomail') . '>';
                                $message = GETPOST('message');
                                $sendtocc = GETPOST('sendtocc');
                                $deliveryreceipt = GETPOST('deliveryreceipt');

                                if (GETPOST('action') === 'send') {
                                    if (dol_strlen(GETPOST('subject')))
                                        $subject = GETPOST('subject');
                                    else
                                        $subject = $langs->transnoentities('Propal') . ' ' . $object->ref;
                                    $actiontypecode = 'AC_PROP';
                                    $actionmsg = $langs->transnoentities('MailSentBy') . ' ' . $from . ' ' . $langs->transnoentities('To') . ' ' . $sendto . ".\n";
                                    if ($message) {
                                        $actionmsg.=$langs->transnoentities('MailTopic') . ": " . $subject . "\n";
                                        $actionmsg.=$langs->transnoentities('TextUsedInTheMessageBody') . ":\n";
                                        $actionmsg.=$message;
                                    }
                                    $actionmsg2 = $langs->transnoentities('Action' . $actiontypecode);
                                }

                                // Create form object
                                include_once(DOL_DOCUMENT_ROOT . '/core/class/html.formmail.class.php');
                                $formmail = new FormMail($db);

                                $attachedfiles = $formmail->get_attached_files();
                                $filepath = $attachedfiles['paths'];
                                $filename = $attachedfiles['names'];
                                $mimetype = $attachedfiles['mimes'];

                                // Envoi de la propal
                                require_once(DOL_DOCUMENT_ROOT . '/core/class/CMailFile.class.php');
                                $mailfile = new CMailFile($subject, $sendto,
                                        $from, $message, $filepath, $mimetype,
                                        $filename, $sendtocc, '',
                                        $deliveryreceipt);

                                if (!$mailfile->error) {
                                    $mailfile->message = stripslashes($mailfile->message);

                                    $msg_prepared = $mailfile->headers . $mailfile->eol;
                                    if (strpos($mailfile->headers, "To: ") === FALSE)
                                        $msg_prepared .= "To: " . $mailfile->getValidAddress($sendto,
                                                        0, 1) . $mailfile->eol2;
                                    $msg_prepared .= $mailfile->subject . $mailfile->eol;
                                    $msg_prepared .= $mailfile->message . $mailfile->eol;


                                    $object->msg_imap_result = store_email_into_folder($msg_prepared,
                                            $conf->global->DOLIMAPMAIL_FOLDER_COPY_SENT_MAIL);
                                }
                            }
                        }
                    }
                    break;
                case 'ordersuppliercard':
                    if (!GETPOST('addfile') && !GETPOST('removedfile') && !GETPOST('cancel')) {
                        $langs->load('mails');

                        $result = $object->fetch(GETPOST("id"));
                        $result = $object->fetch_thirdparty();

                        if ($result > 0) {
                            if (GETPOST('sendto')) {
                                // Le destinataire a ete fourni via le champ libre
                                $sendto = GETPOST('sendto');
                                $sendtoid = 0;
                            }
                            elseif (GETPOST('receiver') != '-1') {
                                // Recipient was provided from combo list
                                if (GETPOST('receiver') === 'thirdparty') { // Id of third party
                                    $sendto = $object->client->email;
                                    $sendtoid = 0;
                                }
                                else { // Id du contact
                                    $sendto = $object->client->contact_get_property(GETPOST('receiver'),
                                            'email');
                                    $sendtoid = GETPOST('receiver');
                                }
                            }

                            if (dol_strlen($sendto)) {
                                $langs->load("commercial");

                                $from = GETPOST('fromname') . ' <' . GETPOST('frommail') . '>';
                                $replyto = GETPOST('replytoname') . ' <' . GETPOST('replytomail') . '>';
                                $message = GETPOST('message');
                                $sendtocc = GETPOST('sendtocc');
                                $deliveryreceipt = GETPOST('deliveryreceipt');

                                if ($_POST['action'] === 'send') {
                                    if (dol_strlen(GETPOST('subject')))
                                        $subject = GETPOST('subject');
                                    else
                                        $subject = $langs->transnoentities('Propal') . ' ' . $object->ref;
                                    $actiontypecode = 'AC_PROP';
                                    $actionmsg = $langs->transnoentities('MailSentBy') . ' ' . $from . ' ' . $langs->transnoentities('To') . ' ' . $sendto . ".\n";
                                    if ($message) {
                                        $actionmsg.=$langs->transnoentities('MailTopic') . ": " . $subject . "\n";
                                        $actionmsg.=$langs->transnoentities('TextUsedInTheMessageBody') . ":\n";
                                        $actionmsg.=$message;
                                    }
                                    $actionmsg2 = $langs->transnoentities('Action' . $actiontypecode);
                                }

                                // Create form object
                                include_once(DOL_DOCUMENT_ROOT . '/core/class/html.formmail.class.php');
                                $formmail = new FormMail($db);

                                $attachedfiles = $formmail->get_attached_files();
                                $filepath = $attachedfiles['paths'];
                                $filename = $attachedfiles['names'];
                                $mimetype = $attachedfiles['mimes'];

                                // Envoi de la propal
                                require_once(DOL_DOCUMENT_ROOT . '/core/class/CMailFile.class.php');
                                $mailfile = new CMailFile($subject, $sendto,
                                        $from, $message, $filepath, $mimetype,
                                        $filename, $sendtocc, '',
                                        $deliveryreceipt);

                                if (!$mailfile->error) {
                                    $mailfile->message = stripslashes($mailfile->message);

                                    $msg_prepared = $mailfile->headers . $mailfile->eol;
                                    if (strpos($mailfile->headers, "To: ") === FALSE)
                                        $msg_prepared .= "To: " . $mailfile->getValidAddress($sendto,
                                                        0, 1) . $mailfile->eol2;
                                    $msg_prepared .= $mailfile->subject . $mailfile->eol;
                                    $msg_prepared .= $mailfile->message . $mailfile->eol;


                                    $object->msg_imap_result = store_email_into_folder($msg_prepared,
                                            $conf->global->DOLIMAPMAIL_FOLDER_COPY_SENT_MAIL);
                                }
                            }
                        }
                    }
                    break;
                case 'invoicesuppliercard':
                    if (!GETPOST('addfile') && !GETPOST('removedfile') && !GETPOST('cancel')) {
                        $langs->load('mails');

                        $result = $object->fetch(GETPOST("id"));
                        $result = $object->fetch_thirdparty();

                        if ($result > 0) {
                            if (GETPOST('sendto')) {
                                // Le destinataire a ete fourni via le champ libre
                                $sendto = GETPOST('sendto');
                                $sendtoid = 0;
                            }
                            elseif (GETPOST('receiver') != '-1') {
                                // Recipient was provided from combo list
                                if (GETPOST('receiver') === 'thirdparty') { // Id of third party
                                    $sendto = $object->client->email;
                                    $sendtoid = 0;
                                }
                                else { // Id du contact
                                    $sendto = $object->client->contact_get_property(GETPOST('receiver'),
                                            'email');
                                    $sendtoid = GETPOST('receiver');
                                }
                            }

                            if (dol_strlen($sendto)) {
                                $langs->load("commercial");

                                $from = GETPOST('fromname') . ' <' . GETPOST('frommail') . '>';
                                $replyto = GETPOST('replytoname') . ' <' . GETPOST('replytomail') . '>';
                                $message = GETPOST('message');
                                $sendtocc = GETPOST('sendtocc');
                                $deliveryreceipt = GETPOST('deliveryreceipt');

                                if (GETPOST('action') === 'send') {
                                    if (dol_strlen(GETPOST('subject')))
                                        $subject = GETPOST('subject');
                                    else
                                        $subject = $langs->transnoentities('Propal') . ' ' . $object->ref;
                                    $actiontypecode = 'AC_PROP';
                                    $actionmsg = $langs->transnoentities('MailSentBy') . ' ' . $from . ' ' . $langs->transnoentities('To') . ' ' . $sendto . ".\n";
                                    if ($message) {
                                        $actionmsg.=$langs->transnoentities('MailTopic') . ": " . $subject . "\n";
                                        $actionmsg.=$langs->transnoentities('TextUsedInTheMessageBody') . ":\n";
                                        $actionmsg.=$message;
                                    }
                                    $actionmsg2 = $langs->transnoentities('Action' . $actiontypecode);
                                }

                                // Create form object
                                include_once(DOL_DOCUMENT_ROOT . '/core/class/html.formmail.class.php');
                                $formmail = new FormMail($db);

                                $attachedfiles = $formmail->get_attached_files();
                                $filepath = $attachedfiles['paths'];
                                $filename = $attachedfiles['names'];
                                $mimetype = $attachedfiles['mimes'];

                                // Envoi de la propal
                                require_once(DOL_DOCUMENT_ROOT . '/core/class/CMailFile.class.php');
                                $mailfile = new CMailFile($subject, $sendto,
                                        $from, $message, $filepath, $mimetype,
                                        $filename, $sendtocc, '',
                                        $deliveryreceipt);

                                if (!$mailfile->error) {
                                    $mailfile->message = stripslashes($mailfile->message);

                                    $msg_prepared = $mailfile->headers . $mailfile->eol;
                                    if (strpos($mailfile->headers, "To: ") === FALSE)
                                        $msg_prepared .= "To: " . $mailfile->getValidAddress($sendto,
                                                        0, 1) . $mailfile->eol2;
                                    $msg_prepared .= $mailfile->subject . $mailfile->eol;
                                    $msg_prepared .= $mailfile->message . $mailfile->eol;

                                    $object->msg_imap_result = store_email_into_folder($msg_prepared,
                                            $conf->global->DOLIMAPMAIL_FOLDER_COPY_SENT_MAIL);
                                }
                            }
                        }
                    }
                    break;
            }
        }
    }

    function printLeftBlock($parameters) {

        global $db, $user, $conf, $langs;

        if (GETPOST('mainmenu') != "dolimapmail" && !($conf->global->DOLIMAPMAIL_FOLDER_ALWAYS_ON_LEFTBLOCK))
            return 0;

        if ($conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE && function_exists('memcache_flush')
                && GETPOST('action') === 'refresh') {
            memcache_flush($memcache_obj);
        }
        if ($conf->global->PAGINATION_WEBMAIL)
            $pagination = $conf->global->PAGINATION_WEBMAIL;
        else
            $pagination = 20;

        if (empty($_GET['num_page']))
            $_GET['num_page'] = 1;
        if (function_exists('imap_open')) {

            require_once(dirname(__FILE__) . '/../class/usermailboxconfig.class.php');
            require_once(dirname(__FILE__) . '/../lib/lib_dolimapmail.php');

            $mailboxconfig = new Usermailboxconfig($db);
            $mailboxconfig->fetch_from_user($user->id);

            $user->mailbox_imap_login = $mailboxconfig->mailbox_imap_login;
            $user->mailbox_imap_password = $mailboxconfig->mailbox_imap_password;
            $user->mailbox_imap_host = $mailboxconfig->mailbox_imap_host;
            $user->mailbox_imap_port = $mailboxconfig->mailbox_imap_port;
            $user->mailbox_imap_ssl = $mailboxconfig->mailbox_imap_ssl;
            $user->mailbox_imap_ssl_novalidate_cert = $mailboxconfig->mailbox_imap_ssl_novalidate_cert;
            $user->mailbox_imap_ref = $mailboxconfig->get_ref();
            $user->mailbox_imap_connector_url = $mailboxconfig->get_connector_url();

            if ($conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE && function_exists('memcache_connect')) {
                $memcache_obj = memcache_connect('localhost',
                        $conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE_PORT);
            }
            else {
                $memcache_obj = FALSE;
            }

            if ($conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE && function_exists('memcache_get')) {
                $menus = memcache_get($memcache_obj,
                        $user->id . '_dolimapmail_menus');
                $unread['dolimapmail_mb_main'] = memcache_get($memcache_obj,
                        $user->id . '_dolimapmail_mb_main_unread');
            }
            else {
                $menus = FALSE;
            }

            if (!$memcache_obj || !$menus) {
                // Connexion
                $mbox = @imap_open($user->mailbox_imap_connector_url,
                                $user->mailbox_imap_login,
                                $user->mailbox_imap_password);
                if (FALSE === $mbox) {
                    return 0;
                }
                else {
                    //$info = imap_mailboxmsginfo($mbox);
                    $info = imap_status($mbox,
                            $user->mailbox_imap_connector_url . $folder,
                            SA_UNSEEN);
                    if (FALSE !== $info) {
                        $unread['dolimapmail_mb_main'] = $info->unseen;
                        $menus = imap_list($mbox, $user->mailbox_imap_ref, '*');
                        sort($menus);
                        if ($conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE && function_exists('memcache_set')) {
                            $res_add = memcache_set($memcache_obj,
                                    $user->id . '_dolimapmail_menus', $menus, 0,
                                    $conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE_TTL);
                            $res_add = memcache_set($memcache_obj,
                                    $user->id . '_dolimapmail_mb_main_unread',
                                    $info->Unread, 0,
                                    $conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE_TTL);
                        }
                    }
                    else {
                        return 0;
                    }
                }
                imap_close($mbox);
            }
            $res_print = '<div class="vmenu">' . "\n";
            $res_print .= '<div class="blockvmenupair">' . "\n";
            $res_print .= '<div class="menu_titre">' . "\n";
            $res_print .= '<a class="vmenu" href="' . dol_buildpath('/dolimapmail/index.php',
                            1) . '?mainmenu=dolimapmail">' . $langs->trans('INBOX');
            if ($unread['dolimapmail_mb_main'])
                $res_print .= ' (' . $unread['dolimapmail_mb_main'] . ')';
            $res_print .= '</a>' . "\n";
            $res_print .= '</div>' . "\n";
            $res_print .= '<div class="menu_top"></div>' . "\n";


            include_once DOL_DOCUMENT_ROOT . "/core/class/menubase.class.php";

            $dolimapmail_menuleft_id = getMenuLeftId();
            $position = 102;
            $nb_menus = sizeof($menus);
            for ($i_menu = 0; $i_menu < $nb_menus; $i_menu++) {
                $m = $menus[$i_menu];
                $cible = $m;
                # Subfolders
                $ex = explode('/', $m);
                while (count($ex) > 1) {
                    $p = array_shift($ex);
                    $m = '&nbsp;&nbsp;' . str_replace($p . "/", '', $m);
                }
                $res_print .= '<div class="menu_contenu">' . "\n";
                $res_print .= '<a class="vsmenu" href="' . dol_buildpath('/dolimapmail/index.php',
                                1) . '?mainmenu=dolimapmail&folder=' . urlencode(str_replace($user->mailbox_imap_ref,
                                        '', $cible)) . '">' . "\n";
                $titre = '';
                $nb_decalage = mb_substr_count($m, 'INBOX.');
                for ($decalage = 0; $decalage < $nb_decalage; $decalage++)
                    $titre .= '&nbsp;&nbsp;';
                $titre .= $langs->trans(sanitize_imap_folder(str_replace($user->mailbox_imap_ref,
                                                '',
                                                str_replace('INBOX.', '', $m)))) . "\n";
                if ($unread_current)
                    $titre .= ' (' . $unread_current . ')';
                $res_print .= $titre;
                $res_print .= '</a>' . "\n";
                $res_print .= '<br /></div>' . "\n";

                if ($conf->global->DOLIMAPMAIL_FOLDER_DBSTORE_MENU && $dolimapmail_menuleft_id
                        > 0) {
                    $menubase = new Menubase($db);
                    $menubase->menu_handler = 'all';
                    $menubase->module = 'dolimapmail';
                    $menubase->type = 'left';
                    $menubase->mainmenu = 'dolimapmail';
                    $menubase->leftmenu = '';
                    $menubase->fk_menu = $dolimapmail_menuleft_id;          // If -1, fk_mainmenu and fk_leftmenu must be defined
                    $menubase->fk_mainmenu = '';
                    $menubase->fk_leftmenu = '';
                    $position++;
                    $menubase->position = $position;
                    $menubase->url = str_replace('&', '&amp;',
                            '/dolimapmail/index.php?mainmenu=dolimapmail&folder=' . urlencode(str_replace($user->mailbox_imap_ref,
                                            '', $cible)));
                    $menubase->target = '';
                    $menubase->titre = $titre;
                    $menubase->langs = 'dolimapmail@dolimapmail';
                    $menubase->perms = '($user->id == ' . $user->id . ')';
                    $menubase->enabled = '($user->id == ' . $user->id . ')';
                    $menubase->user = '2';
                    if (!$menubase->level)
                        $menubase->level = 0;
                    $menubase->create($user);
                }
            }

            $res_print .= '<div class="menu_end"></div>' . "\n";
            $res_print .= '</div>' . "\n";
            $res_print .= '</div>' . "\n";
        }
        if (!($conf->global->DOLIMAPMAIL_FOLDER_DBSTORE_MENU && $dolimapmail_menuleft_id
                > 0)) {
            $this->resprints = $res_print;
        }
        return 0;
    }

    function printTopRightMenu($parameters) {
        global $db, $user, $conf, $langs;
        $langs->load('dolimapmail@dolimapmail');
        return 0;

        if (function_exists('imap_open')) {

            require_once(dirname(__FILE__) . '/../class/usermailboxconfig.class.php' );
            require_once(dirname(__FILE__) . '/../lib/lib_dolimapmail.php');

            $mailboxconfig = new Usermailboxconfig($db);
            $mailboxconfig->fetch_from_user($user->id);

            $user->mailbox_imap_login = $mailboxconfig->mailbox_imap_login;
            $user->mailbox_imap_password = $mailboxconfig->mailbox_imap_password;
            $user->mailbox_imap_host = $mailboxconfig->mailbox_imap_host;
            $user->mailbox_imap_port = $mailboxconfig->mailbox_imap_port;
            $user->mailbox_imap_ssl = $mailboxconfig->mailbox_imap_ssl;
            $user->mailbox_imap_ssl_novalidate_cert = $mailboxconfig->mailbox_imap_ssl_novalidate_cert;
            $user->mailbox_imap_ref = $mailboxconfig->get_ref();
            $user->mailbox_imap_connector_url = $mailboxconfig->get_connector_url();

            if ($conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE && function_exists('memcache_connect')) {
                $memcache_obj = memcache_connect('localhost',
                        $conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE_PORT);
            }
            else {
                $memcache_obj = FALSE;
            }

            if ($conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE && function_exists('memcache_get')) {
                $unread = memcache_get($memcache_obj,
                        $user->id . '_dolimapmail_mb_main__unread');
            }
            else {
                $unread = FALSE;
            }


            if (!$memcache_obj || ($unread !== FALSE)) {
                // Connexion
                $mbox = @imap_open($user->mailbox_imap_connector_url,
                                $user->mailbox_imap_login,
                                $user->mailbox_imap_password);

                if (FALSE === $mbox) {
                    return 0;
                }
                else {
                    $info = imap_status($mbox,
                            $user->mailbox_imap_connector_url, SA_UNSEEN);
                    if (FALSE !== $info) {
                        $unread = $info->unseen;
                        if ($conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE && function_exists('memcache_set')) {
                            $res_add = memcache_set($memcache_obj,
                                    $user->id . '_dolimapmail_mb_main_unread',
                                    $unread, 0,
                                    $conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE_TTL);
                        }
                    }
                    else {
                        return 0;
                    }
                }
                imap_close($mbox);
            }
            if ($unread == 0) {

                $res_print = '<a href="' . dol_buildpath('/dolimapmail/index.php',
                                1) . '?mainmenu=dolimapmail" style="text-decoration:none" alt="' . $langs->trans('notify_unseen') . '">';
                $res_print .= img_picto($langs->trans('seen'),
                        'seen@dolimapmail', 'style="vertical-align:middle"');
                $res_print .= ' (' . $unread . ')</a>';
            }
            else {
                $res_print = '<a href="' . dol_buildpath('/dolimapmail/index.php',
                                1) . '?mainmenu=dolimapmail" style="text-decoration:none" alt="' . $langs->trans('notify_unseen') . '">';
                $res_print .= img_picto($langs->trans('notify_unseen'),
                        'notify_unseen.gif@dolimapmail',
                        'style="vertical-align:middle"');
                $res_print .= ' (' . $unread . ')</a>';
            }
        }

        $this->resprints = $res_print;

        return 1;
    }

}