<?php

/* Copyright (C) 2010 Regis Houssin       <regis@dolibarr.fr>
 * Copyright (C) 2011 Laurent Destailleur <eldy@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *       \file      htdocs/core/ajax/ziptown.php
 *       \ingroup	core
 *       \brief     File to return Ajax response on zipcode or town request
 */
if (!defined('NOTOKENRENEWAL'))
    define('NOTOKENRENEWAL', 1); // Disables token renewal
if (!defined('NOREQUIREMENU'))
    define('NOREQUIREMENU', '1');
if (!defined('NOREQUIREHTML'))
    define('NOREQUIREHTML', '1');
if (!defined('NOREQUIREAJAX'))
    define('NOREQUIREAJAX', '1');
if (!defined('NOREQUIRESOC'))
    define('NOREQUIRESOC', '1');
if (!defined('NOCSRFCHECK'))
    define('NOCSRFCHECK', '1');

$res = 0;
if (!$res && file_exists("../main.inc.php"))
    $res = @include("../main.inc.php");
if (!$res && file_exists("../../main.inc.php"))
    $res = @include("../../main.inc.php");
if (!$res && file_exists("../../../main.inc.php"))
    $res = @include("../../../main.inc.php");
if (!$res && file_exists("../../../../main.inc.php"))
    $res = @include("../../../../main.inc.php");
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../dolibarr/htdocs/main.inc.php");     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res && file_exists("../../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res)
    die("Include of main fails");



/*
 * View
 */

// Ajout directives pour resoudre bug IE
//header('Cache-Control: Public, must-revalidate');
//header('Pragma: public');
//top_htmlhead("", "", 1);  // Replaced with top_httphead. An ajax page does not need html header.
top_httphead();

//print '<!-- Ajax page called with url '.$_SERVER["PHP_SELF"].'?'.$_SERVER["QUERY_STRING"].' -->'."\n";

dol_syslog("GET is " . join(',', $_GET));
//var_dump($_GET);
// Generation of list of zip-town
if (!empty($_GET['reference_' . $_GET['num_ligne']])) {

    $langs->load('dolimapmail@dolimapmail');

    $version = ($conf->global->MAIN_VERSION_LAST_UPGRADE) ? $conf->global->MAIN_VERSION_LAST_UPGRADE : $conf->global->MAIN_VERSION_LAST_INSTALL;
    // basename fields for version >= 3.4
    $soc_rowid = 'rowid';
    $soc_code_client = 'code_client';
    $soc_code_fournisseur = 'code_fournisseur';
    $soc_nom = 'nom';

    $proj_rowid = 'rowid';
    $proj_ref = 'ref';
    $proj_title = 'title';
    $proj_fk_soc = 'fk_soc';

    $prop_rowid = 'rowid';
    $prop_ref = 'ref';
    $prop_ref_client = 'ref_client';
    $prop_fk_soc = 'fk_soc';

    $cmde_rowid = 'rowid';
    $cmde_ref = 'ref';
    $cmde_ref_client = 'ref_client';
    $cmde_fk_soc = 'fk_soc';

    $fct_rowid = 'rowid';
    $fct_ref = 'facnumber';
    $fct_ref_client = 'ref_client';
    $fct_fk_soc = 'fk_soc';

    $prop_frn_rowid = 'rowid';
    $prop_frn_ref = 'ref';
    $prop_frn_ref_supplier = 'ref_ext';
    $prop_frn_fk_soc = 'fk_soc';

    $cmde_frn_rowid = 'rowid';
    $cmde_frn_ref = 'ref';
    $cmde_frn_ref_supplier = 'ref_supplier';
    $cmde_frn_fk_soc = 'fk_soc';

    $fct_frn_rowid = 'rowid';
    $fct_frn_ref = 'ref';
    $fct_frn_ref_fourn = 'ref_supplier';
    $fct_frn_fk_soc = 'fk_soc';

    if ($version < "3.4") {
        $fct_frn_ref = 'rowid';
        $fct_frn_ref_fourn = 'facnumber';
    }

    $return_arr = array();

    $reference = $_GET['reference_' . $_GET['num_ligne']] ? $_GET['reference_' . $_GET['num_ligne']] : '';
    // Recherche parmis les societes
    $sql = "SELECT s.$soc_rowid as rowid, CONCAT_WS(' - ', s.$soc_code_client, s.$soc_code_fournisseur) as reference, s.$soc_nom as nom_societe, 'societe' as type_element, s.$soc_rowid as fk_socid";
    $sql.= " FROM " . MAIN_DB_PREFIX . "societe as s";
    $sql.= " WHERE ";
    $sql.=" (s.$soc_code_client LIKE '%" . $db->escape($reference) . "%' OR s.$soc_nom LIKE '%" . $db->escape($reference) . "%' OR s.$soc_code_fournisseur LIKE '%" . $db->escape($reference) . "%')";
    $sql .= " UNION ";
    // Recherche parmis les projets
    $sql .= "SELECT p.$proj_rowid as rowid, CONCAT_WS(' - ', p.$proj_ref, p.$proj_title) as reference, s.$soc_nom as nom_societe, 'projet' as type_element, s.$soc_rowid as fk_socid";
    $sql.= " FROM " . MAIN_DB_PREFIX . "projet as p";
    $sql.= " LEFT JOIN " . MAIN_DB_PREFIX . "societe as s ON s.$soc_rowid=p.$proj_fk_soc";
    $sql.= " WHERE ";
    $sql.=" (p.$proj_ref LIKE '%" . $db->escape($reference) . "%' OR p.$proj_title LIKE '%" . $db->escape($reference) . "%')";
    $sql .= " UNION ";
    // Recherche parmis les propales clients
    $sql .= "SELECT p.$prop_rowid as rowid, CONCAT_WS(' - ', p.$prop_ref, p.$prop_ref_client) as reference, s.$soc_nom as nom_societe, 'propal' as type_element, s.$soc_rowid as fk_socid";
    $sql.= " FROM " . MAIN_DB_PREFIX . "propal as p";
    $sql.= " LEFT JOIN " . MAIN_DB_PREFIX . "societe as s ON s.$soc_rowid=p.$prop_fk_soc";
    $sql.= " WHERE ";
    $sql.=" (p.$prop_ref LIKE '%" . $db->escape($reference) . "%' OR p.$prop_ref_client LIKE '%" . $db->escape($reference) . "%')";
    $sql .= " UNION ";
    // Recherche parmis les commandes clients
    $sql .= "SELECT c.$cmde_rowid as rowid, CONCAT_WS(' - ', c.$cmde_ref, c.$cmde_ref_client) as reference, s.$soc_nom as nom_societe, 'order' as type_element, s.$soc_rowid as fk_socid";
    $sql.= " FROM " . MAIN_DB_PREFIX . "commande as c";
    $sql.= " LEFT JOIN " . MAIN_DB_PREFIX . "societe as s ON s.$soc_rowid=c.$cmde_fk_soc";
    $sql.= " WHERE ";
    $sql.=" (c.$cmde_ref LIKE '%" . $db->escape($reference) . "%' OR c.$cmde_ref_client LIKE '%" . $db->escape($reference) . "%')";
    $sql .= " UNION ";
    // Recherche parmis les factures clients
    $sql .= "SELECT f.$fct_rowid as rowid, CONCAT_WS(' - ', f.$fct_ref, f.$fct_ref_client) as reference, s.$soc_nom as nom_societe, 'invoice' as type_element, s.$soc_rowid as fk_socid";
    $sql.= " FROM " . MAIN_DB_PREFIX . "facture as f";
    $sql.= " LEFT JOIN " . MAIN_DB_PREFIX . "societe as s ON s.$soc_rowid=f.fk_soc";
    $sql.= " WHERE ";
    $sql.=" (f.$fct_ref LIKE '%" . $db->escape($reference) . "%' OR f.$fct_ref_client LIKE '%" . $db->escape($reference) . "%')";
    $sql .= " UNION ";
    // Recherche parmis les propal fournisseurs
    $sql .= "SELECT p.$prop_frn_rowid as rowid, CONCAT_WS(' - ', p.$prop_frn_ref, p.$prop_frn_ref_supplier) as reference, s.$soc_nom as nom_societe, 'supplier_proposal' as type_element, s.$soc_rowid as fk_socid";
    $sql.= " FROM " . MAIN_DB_PREFIX . "supplier_proposal as p";
    $sql.= " LEFT JOIN " . MAIN_DB_PREFIX . "societe as s ON s.$soc_rowid=p.$prop_frn_fk_soc";
    $sql.= " WHERE ";
    $sql.=" (p.$prop_frn_ref LIKE '%" . $db->escape($reference) . "%' OR p.$prop_frn_ref_supplier LIKE '%" . $db->escape($reference) . "%')";
    $sql .= " UNION ";
    // Recherche parmis les commandes fournisseurs
    $sql .= "SELECT c.$cmde_frn_rowid as rowid, CONCAT_WS(' - ', c.$cmde_frn_ref, c.$cmde_frn_ref_supplier) as reference, s.$soc_nom as nom_societe, 'order_supplier' as type_element, s.$soc_rowid as fk_socid";
    $sql.= " FROM " . MAIN_DB_PREFIX . "commande_fournisseur as c";
    $sql.= " LEFT JOIN " . MAIN_DB_PREFIX . "societe as s ON s.$soc_rowid=c.$cmde_frn_fk_soc";
    $sql.= " WHERE ";
    $sql.=" (c.$cmde_frn_ref LIKE '%" . $db->escape($reference) . "%' OR c.$cmde_frn_ref_supplier LIKE '%" . $db->escape($reference) . "%')";
    $sql .= " UNION ";
    // Recherche parmis les factures fournisseurs
    $sql .= "SELECT f.$fct_frn_rowid as rowid, CONCAT_WS(' - ', f.$fct_frn_ref, f.$fct_frn_ref_fourn) as reference, s.$soc_nom as nom_societe, 'invoice_supplier' as type_element, s.$soc_rowid as fk_socid";
    $sql.= " FROM " . MAIN_DB_PREFIX . "facture_fourn as f";
    $sql.= " LEFT JOIN " . MAIN_DB_PREFIX . "societe as s ON s.$soc_rowid=f.$fct_frn_fk_soc";
    $sql.= " WHERE ";
    $sql.=" (f.$fct_frn_ref LIKE '%" . $db->escape($reference) . "%' OR f.$fct_frn_ref_fourn LIKE '%" . $db->escape($reference) . "%')";
    $sql.= " ORDER BY reference, nom_societe";
    $sql.= $db->plimit(50); // Avoid pb with bad criteria
    //print $sql;
    $resql = $db->query($sql);
    if ($_GET['debug'] == 1)
        print 'SQL : ' . $sql . '<br />' . $db->error . '<br /><hr />';
    //var_dump($db);
    if ($resql) {
        while ($row = $db->fetch_array($resql)) {
            $row_array['label'] = '';
            if ($row['reference'] != '')
                $row_array['label'] = $row['reference'] . ' / ';
            $row_array['label'] .= $row['nom_societe'] . ' (' . $langs->trans('dolimapmail_type_' . $row['type_element']) . ')';
            $row_array['value'] = $row['reference'];
            $row_array['reference_rowid_' . $_GET['num_ligne']] = $row['rowid'];
            $row_array['reference_type_element_' . $_GET['num_ligne']] = $row['type_element'];
            $row_array['reference_fk_socid_' . $_GET['num_ligne']] = $row['fk_socid'];

            array_push($return_arr, $row_array);
        }
    }
    else {
        dol_print_error($db);
    }

    echo json_encode($return_arr);
}
else {
    
}
?>
